"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
var _plugin = /*#__PURE__*/ _interop_require_default(require("tailwindcss/plugin"));
function _define_property(obj, key, value) {
    if (key in obj) {
        Object.defineProperty(obj, key, {
            value: value,
            enumerable: true,
            configurable: true,
            writable: true
        });
    } else {
        obj[key] = value;
    }
    return obj;
}
function _interop_require_default(obj) {
    return obj && obj.__esModule ? obj : {
        default: obj
    };
}
function _object_spread(target) {
    for(var i = 1; i < arguments.length; i++){
        var source = arguments[i] != null ? arguments[i] : {};
        var ownKeys = Object.keys(source);
        if (typeof Object.getOwnPropertySymbols === "function") {
            ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function(sym) {
                return Object.getOwnPropertyDescriptor(source, sym).enumerable;
            }));
        }
        ownKeys.forEach(function(key) {
            _define_property(target, key, source[key]);
        });
    }
    return target;
}
module.exports = (0, _plugin.default)(function(param) {
    var matchUtilities = param.matchUtilities, theme = param.theme;
    matchUtilities({
        timeline: function(value, param) {
            var modifier = param.modifier;
            return {
                animationTimeline: modifier ? "--".concat(modifier) : value
            };
        }
    }, {
        values: {
            DEFAULT: "scroll(y)",
            auto: "auto",
            none: "none",
            "scroll-x": "scroll(x)",
            view: "view()"
        },
        modifiers: "any"
    });
    matchUtilities({
        "scroll-timeline": function(value, param) {
            var modifier = param.modifier;
            return {
                scrollTimeline: (modifier ? "--".concat(modifier, " ") : "none ") + value
            };
        }
    }, {
        values: theme("timelineValues"),
        modifiers: "any"
    });
    matchUtilities({
        "view-timeline": function(value, param) {
            var modifier = param.modifier;
            return {
                viewTimeline: (modifier ? "--".concat(modifier, " ") : "none ") + value
            };
        }
    }, {
        values: theme("timelineValues"),
        modifiers: "any"
    });
    matchUtilities({
        scope: function(value, param) {
            var modifier = param.modifier;
            return {
                timelineScope: "--".concat(modifier)
            };
        }
    }, {
        values: {
            DEFAULT: ""
        },
        modifiers: "any"
    });
    matchUtilities({
        "range-start": function(value) {
            return {
                animationRangeStart: value
            };
        }
    }, {
        values: _object_spread({
            DEFAULT: "entry",
            exit: "exit"
        }, theme("rangeValues"))
    });
    matchUtilities({
        "range-end": function(value) {
            return {
                animationRangeEnd: value
            };
        }
    }, {
        values: _object_spread({
            DEFAULT: "exit",
            entry: "entry"
        }, theme("rangeValues"))
    });
}, {
    theme: {
        timelineValues: {
            DEFAULT: "y",
            block: "block",
            x: "x"
        },
        rangeValues: {
            normal: "normal",
            contain: "contain",
            cover: "cover",
            "entry-crossing": "entry-crossing",
            "exit-crossing": "exit-crossing"
        }
    }
});
